REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	@ECHO OFF
	SET	logPath=%1\FunctionalTester\ifeatureUpdate.log
	SET	regasmutil=%windir%\Microsoft.NET\Framework\v1.1.4322\regasm.exe
	SET	tempfolder=.
	SET	msdnhelpfolder=%1\FunctionalTester\MSDNHelp
	SET	ERR_CODE=0
	SET	result=""	
	SET proxy=updater.rft_specific.siebel.net.611_1.0.0
	SET proxyName=Siebel.net
	SET backupFolder=%1\FunctionalTester\eclipse\plugins\backup\rft61_refreshpack001\%proxy%
    rd /s /q %backupFolder%

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                               Start Install Siebel feature pack
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
CALL :StartLogging

CALL :CreateBackup
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :CheckForDotNetFramework
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :CheckGacUtility
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :CheckCustomInstaller
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallAssemblyFiles
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallCustomFile /i rational_ft_siebel.rftcust 
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallCustomFile /r SiebelDomainProxies.dll 
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallCustomFile /r SiebelIEHelper.dll 
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallCustomFile /r SiebelNotificationListener.dll 
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallCustomFile /h SDK_Sample 
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :ImportRegistryFile siebel_defaultapplicationname.reg
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

CALL :InstallHelp %msdnhelpfolder%
IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

GOTO :EXIT_SUCCESS


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                        Install Help Files
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallHelp 
	IF EXIST %msdnhelpfolder% (
		CALL	:Log "Installing MSDNHelp Files"
	
    	copy Help\msdn %msdnhelpfolder% /y
		IF ERRORLEVEL 1 (
			SET ERR_CODE=1
			SET	result=Error in installing MSDNHelp
			CALL	:Log "Error in installing MSDNHelp"
		) ELSE (
			PUSHD %msdnhelpfolder%
			ECHO PUSHD %msdnhelpfolder%
			installhelpsiebel.bat
			IF ERRORLEVEL 0 (
				CALL	:Log "MSDNHelp has been installed successfully"
			) ELSE (
				SET ERR_CODE=1
				SET	result=Error in installing MSDNHelp
				CALL	:Log "Error in installing MSDNHelp"
				GOTO	:EOF
			)
		)
	) ELSE (
		CALL	:Log "Could not find MSDNHelp Folder" 
		CALL	:Log %msdnhelpfolder%
		CALL	:Log  "Skipping MSDN Help Install"
	)

	

	GOTO	:EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                    Import Registry File
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ImportRegistryFile
	SET	ERR_CODE=0
	CALL :CheckFileExistance %1
	IF %ERR_CODE% == 1 GOTO :EOF

	CALL :Log "Importing Registry File %1 "
	RegEdit	/s %1
	IF ERRORLEVEL 1 (
		SET ERR_CODE=1
		SET result=Failed to Import Registry File %1
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					 Install Custom Files
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallCustomFile
	SET	ERR_CODE=0

	CALL :Log "InstallCustomFile.exe %1 %2"
	InstallCustomFile.exe %1 %2

	IF	%ERRORLEVEL% == 0 (
		SET ERR_CODE=0
		GOTO	:EOF
		) else (
		SET ERR_CODE=1
		IF ERRORLEVEL 1  SET result=ErrorCode 1 : Invalid number of arguments for custom installer
		IF ERRORLEVEL 2  SET result=ErrorCode 2 : Custom File Not Found
		IF ERRORLEVEL 3  SET result=ErrorCode 3 : Custom Folder Not Found
		IF ERRORLEVEL 4  SET result=ErrorCode 4 : Custom Install Command Timed Out
		IF ERRORLEVEL 5  SET result=ErrorCode 5 : Command File Create failure (5)
		IF ERRORLEVEL 6  SET result=ErrorCode 6 : Command File Create failure (6)
		)
	GOTO	:EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Do Regasm
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:RegisterAssembly
	SET	ERR_CODE=0
	CALL	:Log "Registering Assembly...%1"
	%regasmutil%	%1
	IF	ERRORLEVEL 1 (
		SET ERR_CODE=1
		SET result=Failed to Register Assembly
		)
	GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Start Logging 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:StartLogging
	CALL :Log "---------------- Start installing %proxyName% -----------------"
	Date /T	>> %logPath%
	Date /T
	Time /T	>> %logPath%
	Time /T
	CALL :Log "Current Directory:"
	cd >> %logPath%
	cd
	CALL :Log ---------------------------------------------------------------------
	GOTO	:EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Check For Custom Installer 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckCustomInstaller
	CALL :CheckFileExistance InstallCustomFile.exe

	IF %ERR_CODE%==1 (
		SET	result=Custom file installer Not Found
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Create Backup folders (used for uninstall)
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CreateBackup
	CALL :Log "Creating backup folder:"
	CALL :Log %backupFolder%
	mkdir %backupFolder%
	CALL :Log "Populating backup folder:"
	@ECHO ON
	copy /Y uninstall.bat %backupFolder%
	copy /Y install.bat %backupFolder%
	copy /Y InstallCustomFile.exe %backupFolder%
	copy /Y gacutility.exe %backupFolder%
	copy /Y *.dll %backupFolder%
	copy /Y siebel_defaultapplicationname.reg %backupFolder%
	copy /Y rational_ft_siebel.rftcust %backupFolder%
	@ECHO OFF
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check For DotNet Frame Work 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForDotNetFramework
	CALL :CheckFileExistance %regasmutil%

	IF %ERR_CODE%==1 (
		SET	result=.NET FrameworkNotFound
	)
	GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Check GacUtility
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckGacutility
	CALL :CheckFileExistance gacutility.exe
	if %ERR_CODE%==1 (
		SET result=Gacutility not found
	)
	GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					Output result to log file
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Log
	ECHO	%1 	>> %logpath%
	ECHO	%1
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                           Installs all required assemby files to GAC
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallAssemblyFiles
	
	CALL 	:InstallAssemblyFile Interop.cascomlib.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR
	CALL 	:InstallAssemblyFile Interop.Shdocvw.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR
	CALL 	:InstallAssemblyFile Interop.mshtml.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR
	CALL	:InstallAssemblyFile SiebelDomainProxies.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR
	CALL	:InstallAssemblyFile SiebelIEHelper.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR
	CALL	:InstallAssemblyFile SiebelNotificationListener.dll
		IF %ERR_CODE% == 1 GOTO :EXIT_ERROR

	GOTO :EOF 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                           Installs an assembly to Global Assembly cache
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallAssemblyFile
	SET	ERR_CODE=0
	CALL :CheckFileExistance %1
	IF %ERR_CODE%==1 GOTO :EOF
	
	CALL :Log "Installing Assembly %1"
	CALL :Log "    ********** WARNING **********"
	CALL :Log "    gacutility should be invoked on the copy of %1 in the customization dir!"
	CALL :Log "    See RATLC00143270"
	gacutility.exe -a "%tempfolder%\%1" -o

	IF NOT %ERRORLEVEL% == 0 ( 
		CALL :Log "Assembly Install Error"
		GOTO :EOF
	)
		
	CALL :Log "Assembly installed successfully"
	GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	SET	ERR_CODE=0
	IF  EXIST %1 (
		SET result=File Exists
	)else (
		SET result=File Not Found
		SET	ERR_CODE=1
	)
	CALL :Log	"Searching for file %1....%result%"
	GOTO :EOF 

:EXIT_SUCCESS
	call	:Log "-------------------------  Install Status --------------------------- "
	CALL	:Log "%proxyName installed successfully."
	GOTO	:LAST

:EXIT_WARNING
	call	:Log "-------------------------  Install Status --------------------------- "
	CALL	:Log "%proxyName installation Completed with Warning(s)"
	GOTO	:LAST

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EXIT_ERROR
:: We never want to exit with non-0 error status.  Doing so would
:: abort the entire RefreshPack installation.  Not what we want.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:EXIT_ERROR
	CALL	:Log "-------------------------  Install Status --------------------------- "
	CALL	:Log "%proxyName installation Failed  with Error : %result%"
	EXIT	0

:LAST
	call	:Log "--------------------------------------------------------------------- "
