REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	SET	inarg=%~1
REM	SET	inarg=C:\Program Files\IBM\Rational\SDP\6.0
	@ECHO OFF
	SET	logPath="%inarg%\updater\workspace\.metadata\ifeatureUpdate.log"
	SET	regasmutil=%windir%\Microsoft.NET\Framework\v1.1.4322\regasm.exe
	SET	ERR_CODE=0
	SET	result=""	
	SET proxy=updater.rft_specific.siebel.net.611_1.0.0
	SET proxyName=Siebel.net
	SET backupFolder=%inarg%\FunctionalTester\eclipse\plugins\backup\rft61_refreshpack001\%proxy%

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                               Start Install Siebel feature pack
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
CALL :StartLogging
CALL :UnInstallAssembly Interop.cascomlib.dll
CALL :UnInstallAssembly Interop.Shdocvw.dll
CALL :UnInstallAssembly SiebelDomainProxies.dll
CALL :UnInstallAssembly SiebelIEHelper.dll
CALL :UnInstallAssembly SiebelNotificationListener.dll

CALL :UnInstallCustomFile rational_ft_siebel.rftcust
IF %ERR_CODE% == 1 GOTO :ERR_EXIT
	
CALL :Log "Registry entries from %backupFolder%\siebel_defaultapplicationname.reg must be removed manually"
		
GOTO :EXIT_SUCCESS

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					 UnInstall Custom Files
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:UnInstallCustomFile
	CALL :Log "%backupFolder%\InstallCustomFile.exe /u %1"
	"%backupFolder%\InstallCustomFile.exe" /u %1
	IF	%ERRORLEVEL% == 0 (
		SET ERR_CODE=0
	) else (
		SET ERR_CODE=1
		IF ERRORLEVEL 1  SET result=ErrorCode 1 : Invalid number of arguments for custom installer
		IF ERRORLEVEL 2  SET result=ErrorCode 2 : Custom File Not Found
		IF ERRORLEVEL 3  SET result=ErrorCode 3 : Custom Folder Not Found
		IF ERRORLEVEL 4  SET result=ErrorCode 4 : Custom Install Command Timed Out
		IF ERRORLEVEL 5  SET result=ErrorCode 5 : Command File Create failure (5)
		IF ERRORLEVEL 6  SET result=ErrorCode 6 : Command File Create failure (6)
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                           UnInstalls an assembly from Global Assembly cache
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:UnInstallAssembly
	SET	ERR_CODE=0
	CALL :Log "UnInstalling Assembly %1"
	CALL :Log "    ********** WARNING **********"
	CALL :Log "    gacutility should be invoked on the copy of %1 in the customization dir!"
	CALL :Log "    See RATLC00143270"
	"%backupFolder%\gacutility.exe" -a "%backupFolder%\%1" -ou
	GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Start Logging 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:StartLogging
	CALL :Log "---------------- Start UnInstalling %proxyName% ----------"
	Date /T	>> %logPath%
	Date /T
	Time /T	>> %logPath%
	Time /T
	CALL :Log "Current Directory:"
	cd >> %logPath%
	cd
	CALL :Log ---------------------------------------------------------------------
	GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Check For Custom Installer 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckCustomInstaller
	CALL :CheckFileExistance InstallCustomFile.exe

	IF %ERR_CODE%==1 (
		SET	result=Custom file installer Not Found
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					Output result to log file
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Log
	ECHO	%1 	>> %logpath%
	ECHO	%1
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	IF EXIST %1 (
		SET result=File Exists
		SET	ERR_CODE=0
	)else (
		SET result=File Not Found
		SET	ERR_CODE=1
	)
	CALL :Log "Searching for file %1....%result%"
	GOTO :EOF 

:EXIT_SUCCESS
	call	:Log "-------------------------  Uninstall Status --------------------------- "
	CALL	:Log "%proxyName% UnInstalled successfully."
	GOTO	:LAST

:ERR_EXIT
	call	:Log "-------------------------  Uninstall Status --------------------------- "
	CALL	:Log "%proxyName% UnInstall Failed  with Error : %result%"

:LAST
	call	:Log "--------------------------------------------------------------------- "
      
